#include <LEDA/dictionary.h>
#include <LEDA/window.h>


window W(SCREEN_WIDTH,SCREEN_HEIGHT);

void draw_black_node(double x, double y, void* i)
{ W.draw_filled_node(x,y);
  W.draw_ctext(x,y,form("%d",i),white);
 }

void draw_red_node(double x, double y, void* i)
{ W.draw_text_node(x,y,form("%d",i),red); }

void draw_edge(double x0, double y0, double x1, double y1)
{ W.draw_edge(x0,y0,x1,y1,blue); }

declare2(dictionary,int,int)

main()
{
  dictionary(int,int) T;

  int n = W.read_int("n = ");

  init_random();

  if (W.confirm("random"))
    while (n--) T.insert(random(0,100),0);
  else
    for(int i=0;i<n;i++) T.insert(i,0);

  double dy = (W.ymax()-W.ymin())/10;

  T.draw(draw_black_node, draw_red_node,draw_edge, 
         W.xmin(),W.xmax(),W.ymax()-dy,dy);

  W.read_mouse();

}
