/*******************************************************************************
+
+  LEDA  2.1.1                                                 11-15-1991
+
+
+  _corresp.c
+
+
+  Copyright (c) 1991  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 6600 Saarbruecken, FRG     
+  All rights reserved.
+ 
*******************************************************************************/


#include <LEDA/graph_alg.h>

static int edge_ord1(edge& e) { return index(source(e)); }
static int edge_ord2(edge& e) { return index(target(e)); }

bool compute_correspondence(const graph& G, edge_array(edge)& reversal)     
{ int n = G.max_node_i();
  int count = 0;

  edge e,r;

  forall_edges(e,G) reversal[e] = 0;

  list(edge) El = G.all_edges();
  El.bucket_sort(0,n,&edge_ord2);
  El.bucket_sort(0,n,&edge_ord1);
  
  list(edge) El1 = G.all_edges();
  El1.bucket_sort(0,n,&edge_ord1);
  El1.bucket_sort(0,n,&edge_ord2);


  // merge

  while (! El.empty() && ! El1.empty())
  { e = El.head();
    r = El1.head();

    if (target(r) == source(e))
      if (source(r) == target(e))
         { reversal[e] = r;
           El1.pop();
           El.pop();
           count++;
          }
      else
         if (index(source(r)) < index(target(e)))
             El1.pop();
         else
             El.pop();

    else
      if (index(target(r)) < index(source(e)))
          El1.pop();
      else
          El.pop();

    }

  return (count = G.number_of_edges());

}
