.po -3
.TH "Application::DoParseOptions" n "automatically Fri Mar  1 10:58:03 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Application::DoParseOptions \- instance method
.SH TEMPLATE
argsParsed = int
DoParseOptions(char * option, char * nextArgument)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoParseOptions\fP parses a command line option and returns the number of parsed arguments.
.br
The \fImethod ParseCommandLine\fP calls this method for every argument starting with "-". \fBDoParseOptions\fP processes the following options: -Ed, -Eb, -Ec, -Eh, -Em, -Ee, -EE, -Ew, -Ei, -Ep x,y.
.br
This method must be overridden if the application should recognize additional command line options. If the complete command line should be interpreted differently then override the \fImethod ParseCommandLine\fP.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBchar * option
.br
a command line option starting with "-", f.i. "-Eb"
.TP
\fBchar * nextArgument
.br
the next argument behind the \fBoption\fP on the command line, f.i. if \fBoption\fP is the 3rd argument then \fBnextArgument\fP contains the 4th argument. The \fBnextArgument\fP may be useful if \fBoption\fP requires an additional argument.
.br
The \fBnextArgument\fP can be \fBNULL\fP.
.SH RETURN ARGUMENT
.TP
\fBint argsParsed
.br
the number of parsed arguments.
.br
If the command line option uses only the \fBoption\fP then it is 1. If \fBnextArgument\fP is also used then it is 2. If the \fBoption\fP is unknown then 0 must be returned.
.SH CATEGORIES

.na
command line, overrider interface
.ad b

.SH FIRST DEFINITION
class Application
.SH FILES
.PD 0
.TP 20
implementation:
\fBApplication.C

