.po -3
.TH "Application::RemoveDocument" n "automatically Fri Mar  1 10:58:03 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Application::RemoveDocument \- instance method
.SH TEMPLATE
void RemoveDocument(Document * document)
.SH SPECIFIERS
public
.SH DESCRIPTION
\fBRemoveDocument\fP is called by the \fImethod Document::Close\fP when the document has been closed successfully. It removes \fBdocument\fP from the application's list of documents (it calls the method \fBRemove\fP, not \fBRemovePtr\fP, which means the \fBequality test\fP is used to find the document in the collection). The document is then added to the cleanup list of the \fIvar gSystem\fP by the \fImethod System::AddCleanupObject\fP which will delete the document.
.SH ARGUMENTS
.TP
\fBDocument * document
.br
a closed document to be removed and deleted. It must be contained in the \fIinstvar documents\fP.
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
document handling, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBApplication.C

.SH KNOWN PROBLEMS

1. The method should be virtual like its counterpart AddDocument.
.br
2. The document is deleted in any case even if it is not contained in the list.
