.po -3
.nh
.TH "CellSelector" n "automatically Mon Apr  8 20:18:15 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
CellSelector.short \- selection of cells of a CollectionView
.SH DESCRIPTION
The \fBCellSelector\fP selects single cells of a \fBCollectionView\fP.
.br
Instances of \fBCellSelector\fP are created by the \fImethod CollectionView::DoLeftButtonDownCommmand\fP. As long as the mouse button is pressed and the mouse is moved the \fBCellSelector\fP updates the selection of the \fBCollectionView\fP and calls the \fImethod CollectionView::DoOnItem\fP. When the mouse button is released it passes the final selection to the \fImethod CollectionView::DoSelect2\fP.

.br
classes are rarely derived from \fBCellSelector\fP.
.br
class \fBCellSelector\fP
is heavily reused directly.
.br
class \fBCellSelector\fP contains 3 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
Command
.ad b
.PD 0
.TP 20
\fBflags:\fR
CommandFlags

.SH INSTANCE VARIABLES
.TP
.BR clickCount " (private int)"
contains how often the mouse button has been clicked when the \fBCellSelector\fP is created by the \fImethod CollectionView::DoLeftButtonDownCommmand\fP. It is stored here only to be able to pass the number of clicks to the \fImethod CollectionView::DoSelect2\fP when the \fBCellSelector\fP finishes. See \fImethod TrackMouse\fP.

.TP
.BR item " (private Point)"
contains the column and row number of the currently selected cell

.TP
.BR itemptr " (private VObject *)"
refers to the item in the currently selected cell

.TP
.BR lvp " (private CollectionView *)"
a reference to the associated \fBCollectionView\fP. See \fIclass CollectionView\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
CellSelector

.PD 0
.TP 20
miscellaneous
TrackFeedback
.br
TrackMouse

.SH CATEGORIES

.na
Standard Views
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBCollView.h

.SH KNOWN PROBLEMS

1. It is impossible to select more than one cell concurrently though the \fIclass CollectionView\fP would allow this.
.br
2. Because all instance variables are private it is neither possible to implement selection of multiple cells in a subclass.
.SH HISTORY
joe@csesbg.at	Mon Jul 01 18:00 1991
.br
