.po -3
.nh
.TH "ClipBoard" n "automatically Mon Apr  8 20:18:04 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
ClipBoard \- defines the protocol for the ET++ clipboard mechanism
.SH DESCRIPTION
The abstract class \fBClipBoard\fP defines the protocol for the ET++ clipboard mechanism. The clipboard is used to \fBexchange data\fP between different \fBViews\fP either of the same application or of different applications. The data contained in the clipboard has a certain \fBtype\fP which is similar to the document type of the \fIclass Document\fP. The clipboard is used only together with the \fIclass View\fP. \fBViews\fP copy their current selection to and paste data from the clipboard.
.br
Depending on the used window system an instance of a subclass of \fBClipBoard\fP is created at application start-up.

.br
classes are always derived from \fBClipBoard\fP.
.br
class \fBClipBoard\fP
is never reused directly.
.br
class \fBClipBoard\fP is abstract.
.br
class \fBClipBoard\fP contains 13 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
Root
.ad b
.SH INSTANCE VARIABLES
.TP
.BR mb " (protected membuf *)"
is the memory buffer that contains the data of the clipboard. It can be accessed with the \fImethod GetBuf\fP and is filled by the \fImethod MakeBuf\fP.

.TP
.BR owner " (protected bool)"
indicates whether the application is the owner of the current selection.

.TP
.BR type " (protected char *)"
is the type of the data contained in the clipboard. Common types are \fBcDocTypeET\fP which indicates ET++ Object Input/Output format and \fBcDocTypeAscii\fP for pure ASCII text. The \fBtype\fP of the current selection can be accessed with the \fImethod GetType\fP and set with the \fImethod SetType\fP.

.TP
.BR view " (protected View *)"
.br
.B Known Problems:
\fBview\fP is never used.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
CanPaste
.br
GetBuf
.br
GetType
.br
PasteClipboard
.br
SelectionToClipboard
.br
SetType

.PD 0
.TP 20
implementation
ClipBoard
.br
NotOwner
