.po -3
.TH "Collection::Add" n "automatically Fri Mar  1 10:57:30 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Collection::Add \- instance method
.SH TEMPLATE
notAcceptedObject = ObjPtr
Add(ObjPtr anObject)
.SH SPECIFIERS
public
abstract
virtual
.SH DESCRIPTION
Adds \fBanObject\fP to the receiver. The order in which objects are
added does not define their position in the collection. Only subclasses of
the \fIclass SeqCollection\fP preserve the order by adding \fBanObject\fP as last element (except the \fIclass SortedObjList\fP).
.br
If \fBanObject\fP has been added, then 0 is returned. If it has not been
added, then \fBanObject\fP is returned. This is the case, for instance, if
a Set already contains an element equal to \fBanObject\fP.
.br
A succesful Add operation sends the default change message.
.br
Add is the counterpart of \fImethod Remove\fP and \fImethod
RemovePtr\fP.
Method is always overridden.
.SH ARGUMENTS
.TP
\fBObjPtr anObject
.br
An object to be added.
.SH RETURN ARGUMENT
.TP
\fBObjPtr notAcceptedObject
.SH CATEGORIES

.na
manipulation, client interface, overrider
interface
.ad b

.SH FIRST DEFINITION
class Collection
.SH FILES
.PD 0
.TP 20
implementation:
\fBCollection.C

.SH KNOWN PROBLEMS

Some implementations of Add send no change message at all.
