.po -3
.TH "Collection::Empty" n "automatically Fri Mar  1 10:57:30 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Collection::Empty \- instance method
.SH TEMPLATE
void Empty(int initialCapacity)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
Empties the receiver, e.g. its size becomes zero. Note that the
elements are not deleted. Empty sends a change message.
.br
The argument \fBinitialCapacity\fP is a hint indicating an expected number
of elements. Overridden Empty methods may take it into account to improve
performance. A negative initialCapacity is an error (level Warning).
.br
Empty sends the default change message if the size had been greater than 0.
.br
See also \fImethod FreeAll\fP and \fImethod RemoveAll\fP.
Method is often overridden.
.SH ARGUMENTS
.TP
\fBint initialCapacity
.br
Greater or equal 0. initialCapacity is conceptually unsigned but is
declared as \fBint\fP for convenience.
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
manipulation, client interface, overrider interface
.ad b

.SH FIRST DEFINITION
class Collection
.SH FILES
.PD 0
.TP 20
implementation:
\fBCollection.C

.SH KNOWN PROBLEMS

A default argument of 0 should be declared for initialCapacity.
.br
Not all current implementations of Empty consider a negative initialCapacity
as error.
.br
Currently, no implementation of Empty sends a change message.
