.po -3
.TH "Collection::IsEqual" n "automatically Fri Mar  1 10:57:30 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Collection::IsEqual \- instance method
.SH TEMPLATE
see template of Object::IsEqual
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
The current implementation returns \fBTRUE\fP if the argument \fBanObject\fP is a collection of the same class as \fBthis\fP and both
collections are equal. Two collections are equal if they have the same size
and every object in one collection is equal to an object in the other
collection.
Method is rarely overridden.
Method never calls base method.
.SH ARGUMENTS
see arguments of Object::IsEqual
.SH RETURN ARGUMENT
see return argument of Object::IsEqual
.SH CATEGORIES
miscellaneous
.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBCollection.C

.SH KNOWN PROBLEMS

It is impossible to properly define the semantics of Collection::IsEqual. This
method should be abstract.
.br
Two Sets are equal if one Set is subset of the other, and vice versa.
The subset property bases on @Collection::Contains which in turn uses
@Object::IsEqual.
.br
Two SeqCollections are equal if their sequences are equal. Two sequences
are equal if the i-th element in one sequence is equal to the i-th element
in the other sequence.
.br
Note that this definitions cannot be covered by some notions of deep equality!
