.po -3
.TH "Dialog::ShowAt" n "automatically Fri Mar 15 14:08:59 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Dialog::ShowAt \- instance method
.SH TEMPLATE
actionId = int
ShowAt(VObject * father, Point position)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBShowAt\fP updates the window layout, if necessary, sets up the dialog items and opens the dialog window in front of the window of \fBfather\fP at \fBposition\fP. Depending on whether the dialog window is modeless or modefull \fBShowAt\fP either immediately returns or blocks until an \fBActionButton\fP has been selected. In the first case the \fBactionId\fP has no meaning and the button ids should then be checked by overriding the \fImethod Control\fP.
Method is never overridden.
.SH ARGUMENTS
.TP
\fBVObject * father
.br
the dialog is opened over the window that contains \fBfather\fP
.br
.B Known Problems:
If the dialog is modefull and the used window system is SunView, then \fBfather\fP \fBmust not\fP be \fBNULL\fP, otherwise a fatal error is reported and the application aborts.
.TP
\fBPoint position
.br
contains the position where the dialog is opened (with respect to its upper left corner). The \fBposition\fP is additionally modified by the \fImethod GetInitialPos\fP. The resulting coordinates are interpreted relative to the origin of the window that contains \fBfather\fP. If \fBfather\fP is \fBNULL\fP they are used as absolute screen coordinates.
.SH RETURN ARGUMENT
.TP
\fBint actionId
.br
If the dialog window is modefull, then \fBactionId\fP is the id of the \fBActionButton\fP that caused the dialog window to be closed and is then also contained in the \fIinstvar actionId\fP.
.br
If the dialog window is modeless, then \fBShowAt\fP immediately returns and the \fBactionId\fP contains a random value.
.SH CATEGORIES

.na
implementation
.ad b

.SH FIRST DEFINITION
class Dialog
.SH FILES
.PD 0
.TP 20
implementation:
\fBDialog.C

.SH KNOWN PROBLEMS

Due to the problem of the \fBfather\fP argument under SunView it is recommended that \fBShowAt\fP is never called directly but only via the \fImethod Show\fP and the \fImethod ShowOnWindow\fP. These methods make sure that \fBfather\fP is always set.
