.po -3
.TH "Document::DoImport" n "automatically Fri Mar 15 14:13:05 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Document::DoImport \- instance method
.SH TEMPLATE
importCommand = Command *
DoImport(istream & inputStream, FileType * fileType)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoImport\fP is called by the \fImethod Import\fP and must perform the actual import operation. \fBfileType\fP is the type of the file which has been selected in the import dialog and checked by the \fImethod CanImportDocument\fP. The name of the file has been used to create the \fBinputStream\fP. \fBDoImport\fP will normally use the \fBinputStream\fP for reading. But by means of the \fBfileType\fP, which also contains the file name (see \fIclass FileType\fP), it is also possible to open and read the file in a different way. \fBDoImport\fP should create and return an undoable command. For example, a document dealing with text would read the text from the file and create a "paste" command with that text.
.br
The default implementation just returns \fBgNoChanges\fP.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBistream & inputStream
.br
input stream which to import data from
.TP
\fBFileType * fileType
.br
the type of the file from which to import data. \fBfileType\fP has been checked by the \fImethod CanImportDocument\fP.
.SH RETURN ARGUMENT
.TP
\fBCommand * importCommand
.br
an undoable command which will actually insert the imported data into the document
.SH CATEGORIES

.na
input/output, overrider interface
.ad b

.SH FIRST DEFINITION
class Document
.SH FILES
.PD 0
.TP 20
implementation:
\fBDocument.C

