.po -3
.TH "Document::DoMakeWindows" n "automatically Fri Mar 15 14:13:05 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Document::DoMakeWindows \- instance method
.SH TEMPLATE
mainWindow = Window *
DoMakeWindows()
.SH SPECIFIERS
public
abstract
virtual
.SH DESCRIPTION
\fBDoMakeWindows\fP must create the main window of the document. It is called by the \fImethod OpenWindows\fP when the document is opened.
.br
\fBDoMakeWindows\fP creates the window layout as well as one or more views which will display the document's data. The window's and the view's next event handler are set to \fBthis\fP. A typical implementation looks like this:
.na
.nf

Window *MyDocument::DoMakeWindows()
{
    // create a view with "this" as next event handler
    View *myView = new MyView(this, /* document's data */);

    // window's next handler is also "this"
    return new Window(this, Point(300), eWinDefault,
                        new Scroller(myView));
}

.ad b
.fi

.br

Method is always overridden.
.SH ARGUMENTS
none

.SH RETURN ARGUMENT
.TP
\fBWindow * mainWindow
.br
the main window of the document. See \fIinstvar window\fP.
.SH CATEGORIES

.na
windows, overrider interface
.ad b

.SH FIRST DEFINITION
class Document
.SH FILES
.PD 0
.TP 20
implementation:
\fBDocument.C

