.po -3
.TH "Document::DoRead" n "automatically Fri Mar 15 14:13:05 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Document::DoRead \- instance method
.SH TEMPLATE
void DoRead(istream & inputStream, FileType * fileType)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoRead\fP is called by the \fImethod Load\fP and must \fBread the document's data\fP from the \fBinputStream\fP. The data can be read by means of the \fBObject Input/Output Mechanism\fP (see \fIclass Object\fP and \fIcookbook 'Object Input/Output'\fP).
.br
The overridden method should always call the base class' method first so that \fBDocument::DoRead\fP reads the first line of the file which contains the document type and has been written by the \fImethod DoWrite\fP. The following example is the counterpart of the one added for the \fImethod DoWrite\fP:
.na
.nf

void MyDocument::DoRead (istream & is, FileType *ft)
{
    Document::DoRead(is, ft);

    is \>\> op;
}

.ad b
.fi

.br

Method is always overridden.
.SH ARGUMENTS
.TP
\fBistream & inputStream
.br
input stream from which the data is read
.TP
\fBFileType * fileType
.br
the file which is loaded
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
input/output, overrider interface
.ad b

.SH FIRST DEFINITION
class Document
.SH FILES
.PD 0
.TP 20
implementation:
\fBDocument.C

