.po -3
.TH "Document::Load" n "automatically Fri Mar 15 14:13:05 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Document::Load \- instance method
.SH TEMPLATE
fileLoaded = bool
Load(char * fileName, bool unique, FileType * fileType)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
If \fBunique\fP is \fBTRUE\fP, then \fBLoad\fP first checks whether the file is already opened by another document. If there is such a document \fBLoad\fP calls the \fImethod DoFileIsAlreadyOpen\fP and returns \fBFALSE\fP if that method also returns \fBFALSE\fP. Otherwise it creates an input stream and passes it to the \fImethod DoRead\fP. Finally, if there were no errors during reading, it updates the document attributes \fIinstvar isUntitled\fP, \fIinstvar isConverted\fP, \fIinstvar loadDir\fP and \fIinstvar uniqueId\fP.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBchar * fileName
.br
the name of the file to be loaded
.TP
\fBbool unique
.br
indicates whether the file should be opened in unique mode. If \fBunique\fP is \fBFALSE\fP, then the file is opened and loaded in any case. If \fBunique\fP is \fBTRUE\fP, then no other document within the application may have opened the file. If there is such a document and the \fImethod DoFileIsAlreadyOpen\fP returns \fBTRUE\fP, then the file is loaded.
.TP
\fBFileType * fileType
.br
the type of the file to be loaded
.SH RETURN ARGUMENT
.TP
\fBbool fileLoaded
.br
It is \fBTRUE\fP if the file has actually been loaded. It is \fBFALSE\fP if the \fImethod DoFileIsAlreadyOpen\fP returned \fBFALSE\fP or there is something wrong with the file itself. The latter is also indicated by an alert.
.SH CATEGORIES

.na
input/output, client interface, overrider interface
.ad b

.SH FIRST DEFINITION
class Document
.SH FILES
.PD 0
.TP 20
implementation:
\fBDocument.C

.SH KNOWN PROBLEMS

After the file has successfully been loaded \fBPerformCommand(gResetUndo)\fP should be executed instead of deleting the last command manually. See also \fImethod Store\fP.
