.po -3
.TH "Document::MakeFileDialog" n "automatically Fri Mar 15 14:13:05 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Document::MakeFileDialog \- instance method
.SH TEMPLATE
newFileDialog = FileDialog *
MakeFileDialog(FileDialogType fileDialogType)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBMakeFileDialog\fP is called by the \fImethod Open\fP, the \fImethod SaveAs\fP and the \fImethod Import\fP with the corresponding file dialog type. \fBMakeFileDialog\fP must create an appropriate file dialog.
.br
The default implementation gets a new file dialog from the application (see \fImethod Application::MakeFileDialog\fP) whereby the \fBfileDialogType\fP is ignored.
.br
\fBMakeFileDialog\fP is called only once for each type, so all documents within an application share the same file dialogs.
.br
\fBMakeFileDialog\fP is the place where to create own file dialogs to allow user-defined save options (see \fImethod DoWrite\fP).
Method is rarely overridden.
Method rarely calls base method.
.SH ARGUMENTS
.TP
\fBFileDialogType fileDialogType
.br
the type of the file dialog to create. It is either \fBeFDTypeRead\fP, \fBeFDTypeWrite\fP or \fBeFDTypeImport\fP.
.SH RETURN ARGUMENT
.TP
\fBFileDialog * newFileDialog
.br
a new file dialog suitable for read, write or import according to the \fBfileDialogType\fP
.SH CATEGORIES

.na
windows, overrider interface
.ad b

.SH FIRST DEFINITION
class Document
.SH FILES
.PD 0
.TP 20
implementation:
\fBDocument.C

