.po -3
.TH "Document::Open" n "automatically Fri Mar 15 14:13:05 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Document::Open \- instance method
.SH TEMPLATE
newDocOpened = bool
Open()
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBOpen\fP first checks what to do with unsaved changes (see \fImethod AlertChanges\fP). Then it opens the load file dialog. When the user selects a file the \fImethod CanLoadDocument\fP checks whether it can be loaded. If this is the case the file is loaded by the \fImethod Load\fP. If the \fImethod CanLoadDocument\fP returns \fBFALSE\fP, then a new document is created by passing the name of the file to the \fImethod Application::OpenDocument\fP.
Method is rarely overridden.
.SH ARGUMENTS
none

.SH RETURN ARGUMENT
.TP
\fBbool newDocOpened
.br
It is \fBTRUE\fP if a new document has actually been opened. It is \fBFALSE\fP if the user cancelled the operation, did not select a file or storing unsaved changes by the \fImethod Save\fP failed.
.SH CATEGORIES

.na
menu commands, client interface
.ad b

.SH FIRST DEFINITION
class Document
.SH FILES
.PD 0
.TP 20
implementation:
\fBDocument.C

.SH KNOWN PROBLEMS

The command \fBgResetUndo\fP is performed in any case; but it may only be performed after another file has successfully been loaded. The statement \fBLoad(...)\fP should be changed to \fBif (Load(...)) PerformCommand(gResetUndo);\fP or \fBLoad\fP itself should execute \fBgResetUndo\fP. See also \fImethod Load\fP.
