.po -3
.TH "EvtHandler::DoCreateMenu" n "automatically Fri Mar 15 14:09:27 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
EvtHandler::DoCreateMenu \- instance method
.SH TEMPLATE
void DoCreateMenu(Menu * menu)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoCreateMenu\fP is called by the \fImethod VObject::DoRightButtonDownCommand\fP once for each new popup menu before the menu is shown the first time.
.br
Overriding \fBDoCreateMenu\fP gives the possibility to add new menu items or whole submenus to the \fBmenu\fP. A typical implementation first calls the inherited method to allow the base classes and next handlers to add their menu items. Then this handler adds its own items as the following example shows:
.na
.nf

void MyClass::DoCreateMenu (Menu *menu)
{
    MyBaseClass::DoCreateMenu(menu);
    menu-\>AppendItem ("menu command 1", cMENUCMD1);
    menu-\>AppendItems ("-",
			"menu command 2", cMENUCMD2,
			NULL);
}


.ad b
.fi
The default implementation forwards \fBDoCreateMenu\fP to the next handler.
.br
See also \fIclass Menu\fP, \fImethod GetMenu\fP, \fImethod DoSetupMenu\fP and \fImethod DoMenuCommand\fP.
Method is often overridden.
.SH ARGUMENTS
.TP
\fBMenu * menu
.br
a new menu returned by the \fImethod GetMenu\fP to be filled with menu items
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
menus, overrider interface
.ad b

.SH FIRST DEFINITION
class EvtHandler
.SH FILES
.PD 0
.TP 20
implementation:
\fBEvtHandler.C

