.po -3
.TH "EvtHandler::DoSetupMenu" n "automatically Fri Mar 15 14:09:27 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
EvtHandler::DoSetupMenu \- instance method
.SH TEMPLATE
void DoSetupMenu(Menu * menu)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoSetupMenu\fP is called by the \fImethod VObject::DoRightButtonDownCommand\fP immediately before a popup menu is shown. Its purpose is to enable/disable menu items and update the text of these items. All menu items are initially disabled.
.br
A typical implementation follows the style of the \fImethod DoCreateMenu\fP. First the inherited method is called to allow base classes and next handlers to setup their items. Then this handler sets up its own items as the following example shows:
.na
.nf

void MyClass::DoSetupMenu (Menu *menu)
{
    MyBaseClass::DoSetupMenu(menu);

    menu-\>ReplaceItem (cMENUCMD1, "new text of menu command 1");
    if (/* possible to choose command 1 */)
        menu-\>EnableItem (cMENUCMD1);
}


.ad b
.fi
Other examples can be found in the \fImethod Document::DoSetupMenu\fP and the \fImethod TextView::DoSetupMenu\fP.
.br
The default implementation forwards \fBDoSetupMenu\fP to the next handler.
.br
See also \fImethod GetMenu\fP, \fImethod DoCreateMenu\fP and \fImethod DoMenuCommand\fP.
Method is often overridden.
.SH ARGUMENTS
.TP
\fBMenu * menu
.br
a menu whose items must be set up
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
menus, overrider interface
.ad b

.SH FIRST DEFINITION
class EvtHandler
.SH FILES
.PD 0
.TP 20
implementation:
\fBEvtHandler.C

