.po -3
.TH "EvtHandler::SendDown" n "automatically Fri Mar 15 14:09:27 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
EvtHandler::SendDown \- instance method
.SH TEMPLATE
void SendDown(int id, int part, void * value)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBSendDown\fP sends a request down the VObject tree. Similar to the \fImethod Control\fP and the \fImethod Send\fP, \fBSendDown\fP also provides a kind of communication mechanism. \fBControl\fP and \fBSend\fP send an event to the next handler, respectively to the observers. \fBSendDown\fP has the same arguments but instead of events they describe requests or queries to be answered by one or several VObjects of the VObject tree starting at \fBthis\fP. By means of \fBSendDown\fP a VObject up in the hierarchy can request other objects down in the tree to do certain things or return some data.
.br
For example, the \fImethod OneOfCluster::SetItemOn\fP uses \fBSendDown\fP to switch one of the contained buttons on and all others off. The buttons are usually \fBOnOffItems\fP (see \fImethod OnOffItem::SendDown\fP). Another example is the \fImethod Dialog::Control\fP which uses \fBSendDown\fP to "validate" all \fBEditTextItems\fP in the dialog tree (see \fImethod EditTextItem::SendDown\fP).
.br
\fBSendDown\fP should be overridden and forwarded if a VObject has one or several inner VObjects (e.g. the \fImethod CompositeVObject::SendDown\fP).
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBint id
.br
the id of an object or of a certain request
.TP
\fBint part
.br
a code that describes the request more detailed
.TP
\fBvoid * value
.br
an optional argument whose exact type must be determined by the values of \fBid\fP and \fBpart\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
event handling, overrider interface
.ad b

.SH FIRST DEFINITION
class EvtHandler
.SH FILES
.PD 0
.TP 20
implementation:
\fBEvtHandler.C

.SH KNOWN PROBLEMS

Why isn't \fBSendDown\fP first defined in the \fIclass VObject\fP ?
