.po -3
.nh
.TH "Expander" n "automatically Thu Mar 21 20:10:58 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
Expander.short \- arranges and expands VObjects horizontally or vertically
.SH DESCRIPTION
\fBExpanders\fP are used to construct complex window layouts. An \fBExpander\fP arranges its contained VObjects either horizontally or vertically and leaves a certain gap between them. The minimum size of an \fBExpander\fP is determined by the minimum sizes of the inner VObjects. The extra space beyond the minimum size is distributed among all contained VObjects. Fixed VObjects are not resized; other VObjects are expanded evenly to fill the available space. Whether a VObject is horizontally or vertically fixed is indicated by the flags \fBeVObjHFixed\fP and \fBeVObjVFixed\fP (see \fIenum VObjFlags\fP).
.br
It is possible for a subclass to modify the \fIinstvar dir\fP and the \fIinstvar gap\fP during runtime. But afterwards the layout of the \fBExpander\fP or better the complete window layout must be recalculated to make the change effective.

.br
classes are rarely derived from \fBExpander\fP.
.br
class \fBExpander\fP
is often reused directly.
.br
class \fBExpander\fP contains 6 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
CompositeVObject
.ad b
.PD 0
.TP 20
\fBsubclasses:\fR
.na
ScrollBar
.ad b
.PD 0
.TP 20
\fBflags:\fR
CompositeVObjectFlags

.SH INSTANCE VARIABLES
.TP
.BR dir " (protected Direction)"
the direction in which the \fBExpander\fP arranges the contained VObjects. If \fBdir\fP is \fBeHor\fP they are aligned in one row; if it is \fBeVert\fP they are aligned in one column.

.TP
.BR gap " (protected Point)"
is the minimum space the \fBExpander\fP reserves between two VObjects. The actual gap may be greater if the available space for the \fBExpander\fP is greater than its minimum size and some VObjects are not expanded. Depending on the value of the \fIinstvar dir\fP only the \fBx\fP, respectively the \fBy\fP component is used.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
Expander

.PD 0
.TP 20
implementation
ExpandCnt
.br
GetMinSize
.br
SetExtent
.br
SetOrigin

.SH CATEGORIES

.na
VObject Composition
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBExpander.h

.SH KNOWN PROBLEMS

The \fBExpander\fP and other VObject composition classes (such as the \fIclass BorderItem\fP) actively set the fixed flags based on the fixed flags of their contained VObjects. Because this modification is propagated up the VObject tree, it is sometimes hard to find out for which item to set the fixed flags in order to achieve the desired result. In my opinion (joe@csesbg.at), the fixed flags should never be set by composition classes themselves but only by the programmer (as it was in ET++1.0).
.SH HISTORY
joe@csesbg.at	Tue Jun 18 16:01 MET DST 1991	1st version
.br
chris@csesbg.at	Tue Jun 18 17:45 MET DST 1991	reviewed
.br
joe@csesbg.at	Wed Jun 19 21:21 MET DST 1991	last changes & review
.br
