.po -3
.TH "Expander::Expander" n "automatically Thu Mar 21 20:10:58 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Expander::Expander \- instance method
.SH TEMPLATE
void Expander(int id, Direction dir, Point gap = gPoint0, Collection * arrangedVObjects = NULL)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor can be used if a collection of VObjects already exists or if the VObjects are added later.
.br

.br
For example:
.na
.nf

Collection *items = new OrdCollection;
items-\>Add (new Scroller (myView1));
items-\>Add (new Scroller (myView2));
Expander *exp = new Expander (cIdNone, eHor, gPoint8, items);

// Adding the VObjects later:

Expander *exp = new Expander (cIdNone, eHor, gPoint8, NULL);
exp-\>Add (new Scroller (myView1));
exp-\>Add (new Scroller (myView2));

.ad b
.fi

.SH ARGUMENTS
.TP
\fBint id
.br
the id of \fBthis\fP
.TP
\fBDirection dir
.br
see \fIinstvar dir\fP
.TP
\fBPoint gap = gPoint0
.br
see \fIinstvar gap\fP
.TP
\fBCollection * arrangedVObjects = NULL
.br
the VObjects to be arranged by \fBthis\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBExpander.C

.po -3
.TH "Expander::Expander" n "automatically Thu Mar 21 20:10:58 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Expander::Expander \- instance method
.SH TEMPLATE
void Expander(int id, Direction dir, Point gap, VObject * firstVObject, ellipsis ...)
.SH SPECIFIERS
public
.SH DESCRIPTION
This constructor is usually used when a complete \fBVObject\fP tree is created with a single statement.
.br

.br
For example:
.na
.nf

VObject *layout =
        new Expander (cIdNone, eVert, gPoint8,
                new BorderItem ("Scrollers",
                        new Expander (cIdNone, eHor, gPoint4,
                                new Scroller (myView1),
                                new Scroller (myView2),
                                NULL        // end of list of 2nd Expander
                        )
                ),
                new Scroller (myView3),
                NULL        // end of list of 1st Expander
        );

.ad b
.fi

.SH ARGUMENTS
.TP
\fBint id
.br
the id of \fBthis\fP
.TP
\fBDirection dir
.br
see \fIinstvar dir\fP
.TP
\fBPoint gap
.br
see \fIinstvar gap\fP
.TP
\fBVObject * firstVObject
.br
the first one of the VObjects to be arranged by \fBthis\fP
.TP
\fBellipsis ...
.br
a \fBNULL\fP terminated list with the remaining VObjects to be arranged by \fBthis\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBExpander.C

