.po -3
.nh
.TH "FloatItem" n "automatically Mon Apr  8 20:19:24 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
FloatItem.short \- an editable floating point number
.SH DESCRIPTION
A \fBFloatItem\fP allows the user to enter a floating point value. The allowed format, given as GNU emacs regular expression, is: \fB(+|-)?[0-9]*(.[0-9]*)?([eE](+|-)?[0-9]*)?\fP, which means decimal or exponential notation.
.br
It is possible to restrict the value to a certain range. When the dialog, containing the \fBFloatItem\fP, is accepted, the entered value is checked against that range.
.br
A \fBFloatItem\fP is often installed in an \fBEnumItem\fP. In this case the \fBFloatItem\fP can also have an incremental step which is added, respectively subtracted when the up or down button of the \fBEnumItem\fP is pressed. So the user can choose between entering a value directly or using the \fBEnumItem\fP to cycle through the allowed range.
.br
See also the \fIclass NumItem\fP.

.br
classes are never derived from \fBFloatItem\fP.
.br
class \fBFloatItem\fP
is often reused directly.
.br
class \fBFloatItem\fP contains 13 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
EditTextItem
.ad b
.PD 0
.TP 20
\fBflags:\fR
ClipperFlags

.SH INSTANCE VARIABLES
.TP
.BR inc " (private float)"
The increment value is added or subtracted from the current value if the \fBFloatItem\fP is installed in an \fBEnumItem\fP or if the \fImethod Incr\fP, respectively the \fImethod Decr\fP is called directly.

.TP
.BR maxVal " (private float)"
the allowed maximum value. It can be accessed with the \fImethod GetRange\fP and the \fImethod SetRange\fP.

.TP
.BR minVal " (private float)"
the allowed minimum value. It can be accessed with the \fImethod GetRange\fP and the \fImethod SetRange\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
Decr
.br
FloatItem
.br
GetInc
.br
GetRange
.br
GetValue
.br
Incr
.br
SetInc
.br
SetRange
.br
SetValue

.PD 0
.TP 20
implementation
PrintOn
.br
ReadFrom
.br
SendDown
.br
Validate

.SH CATEGORIES

.na
Simple Dialog Items
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBFloatItem.h

.SH HISTORY
joe@csesbg.at	Thu Sep 05 12:49 1991 MET DST
.br
