.po -3
.TH "Form::Form" n "automatically Mon Apr  8 20:17:11 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Form::Form \- instance method
.SH TEMPLATE
void Form(int id, VObjAlign align, Point gap, VObject * label, ellipsis ...)
.SH SPECIFIERS
public
.SH DESCRIPTION
Example how to use:
.na
.nf

Form *formItem =
     new Form(cIdNone, eVObjHCenter, gPoint2,
           new TextItem("Find What:"),
           new BorderItem(new EditTextItem(cIdFind, "", 100)),
           new TextItem("Change To:"),
           new BorderItem(new EditTextItem(cIdChange, "", 100)),
           NULL);

.ad b
.fi

.SH ARGUMENTS
.TP
\fBint id
.br
the id of the \fBForm\fP
.TP
\fBVObjAlign align
.br
how to align the items. See also \fIenum VObjAlign\fP.
.TP
\fBPoint gap
.br
the minimum gap between the items
.TP
\fBVObject * label
.br
A \fBNULL\fP-terminated list of pairs of label items and data entry items is expected here. See also the example.
.TP
\fBellipsis ...
.br
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBForm.C

.po -3
.TH "Form::Form" n "automatically Mon Apr  8 20:17:11 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Form::Form \- instance method
.SH TEMPLATE
void Form(int id, VObjAlign align = eVObjHCenter, Point gap = gPoint0, Collection * items = NULL)
.SH SPECIFIERS
public
.SH DESCRIPTION
Example how to use:
.na
.nf

Collection *list = new OrdCollection;
list-\>Add(new TextItem("Find What:"));
list-\>Add(new BorderItem(new EditTextItem(cIdFind, "", 100)));
list-\>Add(new TextItem("Change To:"));
list-\>Add(new BorderItem(new EditTextItem(cIdChange, "", 100)));
Form *formItem = new Form(cIdNone, eVObjHCenter, gPoint2, list);

.ad b
.fi

.SH ARGUMENTS
.TP
\fBint id
.br
the id of the \fBForm\fP
.TP
\fBVObjAlign align = eVObjHCenter
.br
how to align the items. See also \fIenum VObjAlign\fP.
.TP
\fBPoint gap = gPoint0
.br
the minimum gap between the items
.TP
\fBCollection * items = NULL
.br
It should contain pairs of labels and data entry items. See also the example.
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBForm.C

.po -3
.TH "Form::Form" n "automatically Mon Apr  8 20:17:11 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Form::Form \- instance method
.SH TEMPLATE
void Form(int id, VObjAlign align, Point gap, char * label, ellipsis ...)
.SH SPECIFIERS
public
.SH DESCRIPTION
Example how to use:
.na
.nf

Form *formItem =
        new Form(cIdNone, eVObjHCenter, gPoint2,
                  "Find What:", new EditTextItem(cIdFind, "", 100),
                  "Change To:", new EditTextItem(cIdChange, "", 100),
                  NULL);

.ad b
.fi

.SH ARGUMENTS
.TP
\fBint id
.br
the id of the \fBForm\fP
.TP
\fBVObjAlign align
.br
how to align the items. See also \fIenum VObjAlign\fP.
.TP
\fBPoint gap
.br
the minimum gap between the items
.TP
\fBchar * label
.br
A \fBNULL\fP-terminated list of pairs of strings and \fBVObjects\fP is expected here. Each \fBVObject\fP is automatically put into a \fBBorderItem\fP. See also the example.
.TP
\fBellipsis ...
.br
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBForm.C

