.po -3
.nh
.TH "ImageButton" n "automatically Thu Mar 21 20:12:53 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
ImageButton \- a button with a graphic image
.SH DESCRIPTION
The \fBImageButton\fP is used to trigger an action, similar to the \fIclass ActionButton\fP. But instead of a string or a \fBVObject\fP it contains two bitmaps. The first one is drawn when the button is unselected. The second is displayed as a feedback to the user as long as the button is pressed. On selection the \fBImageButton\fP sends its id and the partcode \fBcPartToggle\fP via \fBControl\fP to its next event handlers.

.br
classes are never derived from \fBImageButton\fP.
.br
class \fBImageButton\fP
is sometimes reused directly.
.br
class \fBImageButton\fP contains 7 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
Button
.ad b
.PD 0
.TP 20
\fBsubclasses:\fR
.na
ScrollBarButton
.ad b
.PD 0
.TP 20
\fBflags:\fR
ButtonFlags

.SH INSTANCE VARIABLES
.TP
.BR bm1 " (protected Bitmap *)"
This bitmap is displayed when the button is unselected. \fBbm1\fP must not be \fBNULL\fP.

.TP
.BR bm2 " (protected Bitmap *)"
This bitmap is displayed as a feedback to the user as long as the button is pressed. \fBbm2\fP must not be \fBNULL\fP.

.TP
.BR idleEvents " (protected bool)"
controls whether idle events are reported during selection of the button. Its effect is the same as the flag \fBeButtonIdle\fP (see \fImethod Button::DoOnItem\fP).
.br
.B Known Problems:
\fBidleEvents\fP should be stored in the flag \fBeButtonIdle\fP. Overriding \fBDoLeftButtonDownCommand\fP would not be necessary then.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
ImageButton

.PD 0
.TP 20
implementation
DoLeftButtonDownCommand
.br
DrawInner
.br
GetMinSize
.br
PrintOn
.br
ReadFrom
.br
~ImageButton

.SH CATEGORIES

.na
Simple Dialog Items
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBButtons.h

.SH HISTORY
joe@csesbg.at	Fri Sep 06 10:50 1991 MET DST
.br
.so mann/ImageButton::DoLeftButtonDownCommand.n
.so mann/ImageButton::DrawInner.n
.so mann/ImageButton::GetMinSize.n
.so mann/ImageButton::ImageButton.n
.so mann/ImageButton::PrintOn.n
.so mann/ImageButton::ReadFrom.n
.so mann/ImageButton::~ImageButton.n
