.po -3
.nh
.TH "ManyOfCluster" n "automatically Thu Mar 21 20:10:06 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
ManyOfCluster \- several buttons may be on at the same time
.SH DESCRIPTION
The \fBManyOfCluster\fP manages a group of two-state buttons whereby several of these buttons may be in state "on" at the same time (in contrast to the \fIclass OneOfCluster\fP). Usually \fBLabeledButtons\fP, with an instance of the \fIclass ToggleButton\fP inside, are put in a \fBManyOfCluster\fP.
.br
If one of the buttons is switched on or off, then next handlers are notified about this event via the method \fBControl\fP with the following arguments: the id of the \fBManyOfCluster\fP, the id of the button, the new state of the button. Therefore it is important to assign an id to the \fBManyOfCluster\fP. See the \fImethod ChangeDialog::DoCreateDialog\fP for an example.

.br
classes are never derived from \fBManyOfCluster\fP.
.br
class \fBManyOfCluster\fP
is sometimes reused directly.
.br
class \fBManyOfCluster\fP contains 9 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
Cluster
.ad b
.PD 0
.TP 20
\fBflags:\fR
CompositeVObjectFlags

.SH INSTANCE VARIABLES
.TP
.BR bits " (private int)"
is unused


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
IsItemOn
.br
ManyOfCluster
.br
SetAllItemsOff
.br
SetAllItemsOn
.br
SetItemOff
.br
SetItemOn

.PD 0
.TP 20
implementation
Control

.SH CATEGORIES

.na
VObject Composition
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBManyOfCluster.h

.SH HISTORY
joe@csesbg.at	Mon Sep 09 09:51 1991 MET DST
.br
.so mann/ManyOfCluster::Control.n
.so mann/ManyOfCluster::IsItemOn.n
.so mann/ManyOfCluster::ManyOfCluster.n
.so mann/ManyOfCluster::SetAllItemsOff.n
.so mann/ManyOfCluster::SetAllItemsOn.n
.so mann/ManyOfCluster::SetItemOff.n
.so mann/ManyOfCluster::SetItemOn.n
