.po -3
.nh
.TH "NumItem" n "automatically Mon Apr  8 20:18:24 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
NumItem \- an editable integer number
.SH DESCRIPTION
A \fBNumItem\fP allows the user to enter an integer value. The allowed format, given as GNU emacs regular expression, is: \fB(+|-)?[0-9]*\fP.
.br
It is possible to restrict the value to a certain range. When the dialog, containing the \fBNumItem\fP, is accepted, the entered value is checked against that range.
.br
A \fBNumItem\fP is often installed in an \fBEnumItem\fP. In this case the \fBNumItem\fP can also have an incremental step which is added, respectively subtracted when the up or down button of the \fBEnumItem\fP is pressed. So the user can choose between entering a value directly or using the \fBEnumItem\fP to cycle through the allowed range.
.br
See the \fIclass GotoDialog\fP how to create a \fBNumItem\fP, and especially how to use it together with the \fBEnumItem\fP.
.br
See also the \fIclass FloatItem\fP.

.br
classes are never derived from \fBNumItem\fP.
.br
class \fBNumItem\fP
is often reused directly.
.br
class \fBNumItem\fP contains 13 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
EditTextItem
.ad b
.PD 0
.TP 20
\fBflags:\fR
ClipperFlags

.SH INSTANCE VARIABLES
.TP
.BR inc " (private int)"
The increment value is added or subtracted from the current value if the \fBNumItem\fP is installed in an \fBEnumItem\fP or if the \fImethod Incr\fP, respectively the \fImethod Decr\fP is called directly.

.TP
.BR maxVal " (private int)"
the allowed maximum value. It can be accessed with the \fImethod GetRange\fP and the \fImethod SetRange\fP.

.TP
.BR minVal " (private int)"
the allowed minimum value. It can be accessed with the \fImethod GetRange\fP and the \fImethod SetRange\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
Decr
.br
GetInc
.br
GetRange
.br
GetValue
.br
Incr
.br
NumItem
.br
SetInc
.br
SetRange
.br
SetValue

.PD 0
.TP 20
implementation
PrintOn
.br
ReadFrom
.br
SendDown
.br
Validate

.SH CATEGORIES

.na
Simple Dialog Items
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBNumItem.h

.SH HISTORY
joe@csesbg.at	Thu Sep 05 12:49 1991 MET DST
.br
.so mann/NumItem::Decr.n
.so mann/NumItem::GetInc.n
.so mann/NumItem::GetRange.n
.so mann/NumItem::GetValue.n
.so mann/NumItem::Incr.n
.so mann/NumItem::NumItem.n
.so mann/NumItem::PrintOn.n
.so mann/NumItem::ReadFrom.n
.so mann/NumItem::SendDown.n
.so mann/NumItem::SetInc.n
.so mann/NumItem::SetRange.n
.so mann/NumItem::SetValue.n
.so mann/NumItem::Validate.n
