.po -3
.TH "Object::AbstractMethod" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::AbstractMethod \- instance method
.SH TEMPLATE
void AbstractMethod(char * methodName)
.SH SPECIFIERS
public
.SH DESCRIPTION
\fBAbstractMethod\fP is to be called in the body of an abstract method.
Calling \fBAbstractMethod\fP results in a warning (see Error Handling,
DoError), so the client eventually sees that he has forgot to override the
calling method. As good programming practice, every abstract method should
call it.
.br
Note that the methodName should not be qualified, i.e the class name will
be automatically prepended.
.br
\fBAbstractMethod\fP is a standardized short-cut to trigger the error
handler (see DoError). Using \fBAbstractMethod\fP makes the code more
expressive.
.br
See also \fImethod MayNotUse\fP (and \fImethod Warning\fP etc.).
For non-regular classes, there is the function AbstractMethod (see
"Error.[hC]") with the same purpose.
.SH ARGUMENTS
.TP
\fBchar * methodName
.br
the (unqualified) name of an abstract method
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
fire walls, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

