.po -3
.TH "Object::Clone" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::Clone \- instance method
.SH TEMPLATE
clone = ObjPtr
Clone()
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
Returns a \fBshallow copy\fP of the receiver. Shallow copying
accomplishes what a copy constructor would do.
.br
See also \fImethod DeepClone\fP.
The default implementation does it by bit-wise copy, so Clone has to be
overridden in several cases:
.br
(1) if the clone needs new instances of auxilliary objects (since they
would be shared with the source object - the receiver - otherwise).
.br
(2) if the class has embedded objects whose constructors should have been
called.
.br
(3) if the source object has some instance variables whose value are not
correct for the clone. Generally speaking, these instance variables contain
values that are specific for one particular object. Note that this might
concern non-pointer variables, too.
.br

.br
According to the semantics of Clone, the client can answer wether and how
he has to override Clone by the following rule-of-thumb: If the net effects
of the inherited Clone differ from what a (fictivous) copy constructor
should do for that class, Clone has to be overridden accordingly.
.br
A good example of a different (and general) re-implementation is \fImethod Collection::Clone\fP. It creates a new instance of the same collection
class and adds all objects contained in the source collection one by one to
the clone.
Method is rarely overridden.
.SH ARGUMENTS
none

.SH RETURN ARGUMENT
.TP
\fBObjPtr clone
.br
a shallow copy of the object
.SH CATEGORIES

.na
copying, client interface, overrider interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

