.po -3
.TH "Object::Compare" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::Compare \- instance method
.SH TEMPLATE
result = int
Compare(ObjPtr anObject)
.SH SPECIFIERS
public
abstract
virtual
.SH DESCRIPTION
\fBCompare\fP compares the receiver with \fBanObject\fP and returns
an integer describing the ordering.
.br
Object's Compare is abstract.
.br
The typical implementation first checks by means of the \fImacro
IsKindOf\fP or the \fImacro Guard\fP whether \fBanObject\fP is of the
same class as \fBthis\fP. Then it compares the objects based on the values
of some instance variables. See also \fImethod IsEqual\fP.
.br
\fBExamples\fP
.br
\fImethod ByteArray::Compare\fP, \fImethod ObjInt::Compare\fP, \fImethod VObject::Compare\fP.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBObjPtr anObject
.br
an object which is compared with \fBthis\fP
.SH RETURN ARGUMENT
.TP
\fBint result
.br
negative, zero or positive depending on whether the receiver is less than,
equal to or greater than \fBanObject\fP. The comparison result follows the same
convention like the function \fBstrcmp\fP)
.SH CATEGORIES

.na
comparison, collection support, client
interface, overrider interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

.SH KNOWN PROBLEMS

See \fImethod IsEqual\fP.
