.po -3
.TH "Object::DeepClone" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::DeepClone \- instance method
.SH TEMPLATE
deepClone = ObjPtr
DeepClone()
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
Returns a \fBdeep copy\fP of the receiver. In contrast to the \fImethod Clone\fP, it recursively applies DeepClone for all 
part objects of the receiver.
.br
So the \fBdeepClone\fP is a copy of the object graph originating in the
receiver. Note that a referenced object shall not be not necessarily
deep-cloned. This is the case, for example, if the referenced object is not
part of the receiver, but acquainted to it only. Acquainted objects are
objects providing some services, for instance. The deep-clone may either
share such an object with the source object, or may have set the
corresponding instance variable to nil.
.br
The default implementation uses \fBObject Input/Output\fP to do the
job. Thus, it depends on the implementation of the \fImethod PrintOn\fP
and the \fImethod ReadFrom\fP. Except for objects that must not be
instantiated more than once (so-called atoms, like Styles for instance)
even if they are written or read via object i/o, there are no examples
in ET++ where the semantics of ReadFrom and PrintOn for a certain class
would be not appropriate for deep-cloning, too.
.br
But it is not excluded (until proven the opposite), that such a difference
might be the case.
.br
Doing Object I/O for atoms is extremely difficult in ET++ V2.2. In the
future, there will be support for that.
.br
Because copying with Object I/O is rather slow, this method may be
overridden for small and less complex objects like it is done by the \fIclass ObjInt\fP or the \fIclass BitSet\fP.
Method is rarely overridden.
.SH ARGUMENTS
none

.SH RETURN ARGUMENT
.TP
\fBObjPtr deepClone
.br
a deep copy of the object
.SH CATEGORIES

.na
copying, client interface, overrider interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

