.po -3
.TH "Object::ReadFrom" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::ReadFrom \- instance method
.SH TEMPLATE
inputStream = istream &
ReadFrom(istream & inputStream)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
ReadFrom is the counterpart of PrintOn. It is a hook for the
operator>>. In analogy to PrintOn, it applies operator>> to the
instance variables of the receiver. All statements made for PrintOn hold
for ReadFrom as well (except for the separating white-spaces).
.br
The operator>> does the book-keeping of objects already read in, and
creates a new object of the appropriate class. ReadOn finally
re-initializes the object. ReadFrom can be viewed as a dynamically bound
constructor. Like for real C++ constructors, the base class's constructor
is executed before the derived class's constructor.
.br
The class of an object is determined by the contents read from the stream.
Clearly, the pointer variable's type holding the object must be conformant
to a pointer to objects of that peculiar class. This is checked by the
operator>>. If the type of the pointer variable is not conformant, an
error is issued.
.br
Object' implementation is special insofar that it re-establishes the
observers of the receiver (provided they have been output).
.br
See \fImethod PrintOn\fP for more informations and examples, 
and see also \fItechnote 'Object Input/Output'\fP.
Method is often overridden.
.SH ARGUMENTS
.TP
\fBistream & inputStream
.br
the input stream this object is to be read
from
.SH RETURN ARGUMENT
.TP
\fBistream & inputStream
.br
the same input stream which has been given
as argument
.SH CATEGORIES

.na
object i/o, overrider interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

.SH KNOWN PROBLEMS

Since a ReadFrom is applied to an Object that has been obtained by
@Object::New, pointer instance variables may already point to objects (or
allocated memory, respectively). This depends on how InitNew is implemented
for the class in question. If InitNew creates a object for a pointer
instance variable, that object must be deleted in ReadFrom before applying
operator>>. Otherwise, a lot of unreferenced objects might be
produced.
