.po -3
.TH "Object::Send" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::Send \- instance method
.SH TEMPLATE
void Send(int objectId = -1, int partCode = cPartAnyChange, void * value = 0)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
Sends the change message described by the arguments to all observers
of the receiver. Eventually, the \fImethod DoObserve\fP operation of
the observers is invoked, so they can appropriately react.
.br
See also \fImethod Changed\fP.
.br
The \fIclass EvtHandler\fP overrides this method to additionally
forward the change message to the next handler. The next handler handles
the change message in \fImethod Control\fP!. Thus, Control is another,
more specific mean to distribute change messages.
.br
Examples: \fImethod VObject::SetOrigin\fP, \fImethod
VObject::SetExtent\fP.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBint objectId = -1
.br
the id of the object which has changed or \fIconst cIdNone\fP.  The
current implementation literally uses -1 as default argument instead of
\fIconst cIdNone\fP. This is a (minor) bug which will be fixed in
future versions.
.TP
\fBint partCode = cPartAnyChange
.br
a code that describes what aspect of the observed object has changed.
Usually, the constants defining the part code values have names of the form
\fBcPart...\fP.
.TP
\fBvoid * value = 0
.br
an argument whose actual type and semantics depends on the values
of \fBobjectId\fP and \fBpartCode\fP.
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
change propagation, client interface
.ad b

.SH FIRST DEFINITION
class Object
.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

