.po -3
.TH "Object::guard" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::guard \- instance method
.SH TEMPLATE
checkedPointer = ObjPtr
guard(Class * class)
.SH SPECIFIERS
public
.SH DESCRIPTION
Checks whether this object is an instance of the \fBclass\fP. If
this is the case, then it returns the receiver, otherwise an error (category
error) is issued, and the return value is nil.
.br
This method is usually not directly called. The \fImacro Guard\fP is
the interface for this method, since the macro's value has the static type
of (<class> *). Thus, the client does not need to cast the expresson.
See also \fImacro IsKindOf\fP.
.br
This method and therefore the \fImacro Guard\fP and the \fImacro
IsKindOf\fP require that \fBclass descriptors are properly set up
\fP.
.br
See also \fItechnote Metaclasses\fP.
.SH ARGUMENTS
.TP
\fBClass * class
.br
the class descriptor of the class which the receiver shall be instance
of.
.br
Class descriptors may be literally denoted with the \fImacro Meta\fP.
For example, \fBMeta(Window)\fP if the desired class is \fBWindow\fP.
.SH RETURN ARGUMENT
.TP
\fBObjPtr checkedPointer
.br
.SH CATEGORIES

.na
metaclass, implementation
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

