.po -3
.TH "Object::~Object" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::~Object \- instance method
.SH TEMPLATE
void ~Object()
.SH SPECIFIERS
public
.SH DESCRIPTION
Object declares its destructor as virtual, so for all regular classes,
destruction always works correctly (s. ARM).
.br
If an object is about to be deleted, all its observers are notified about
this fact by the change propagation mechanism. They receive cPartSenderDied
as the part code argument of \fImethod DoObserve\fP.
.br
\fBImportant Note:\fP If the client re-implements the change
propagation mechanism in a particular class, then the notification of the
observers (about the death) must be done in that class's destructor,
because Object's destructor would not invoke the overridden Send!
.br
As an implementation detail, the object about to deleted is removed from
the global object table through the \fImethod ObjectTable::Remove\fP.
It has been inserted into the object table by Object's constructor.
.SH ARGUMENTS
none

.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
destructor
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

