.po -3
.nh
.TH "OneOfCluster" n "automatically Thu Mar 21 20:11:28 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
OneOfCluster \- only one button can be on at the same time
.SH DESCRIPTION
The \fBOneOfCluster\fP manages a group of two-state buttons whereby always only one button may be in state "on" at the same time (in contrast to the \fIclass ManyOfCluster\fP). Usually \fBLabeledButtons\fP, with an instance of the \fIclass RadioButton\fP inside, are put in a \fBOneOfCluster\fP.
.br
If a button is selected, then it is switched on and all other buttons are switched off. Next handlers are notified about the selection via the method \fBControl\fP with the following arguments: the id of the \fBOneOfCluster\fP, the id of the selected button, the new state of the button which is always \fBTRUE\fP. Therefore it is important to assign an id to the \fBOneOfCluster\fP. See the \fImethod ChangeDialog::DoCreateDialog\fP for an example.

.br
classes are never derived from \fBOneOfCluster\fP.
.br
class \fBOneOfCluster\fP
is sometimes reused directly.
.br
class \fBOneOfCluster\fP contains 7 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
Cluster
.ad b
.PD 0
.TP 20
\fBflags:\fR
CompositeVObjectFlags


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
GetCurrentItem
.br
OneOfCluster
.br
SetItemOn

.PD 0
.TP 20
implementation
Control
.br
Init

.SH CATEGORIES

.na
VObject Composition
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBOneOfCluster.h

.SH HISTORY
joe@csesbg.at	Mon Sep 09 09:51 1991 MET DST
.br
.so mann/OneOfCluster::Control.n
.so mann/OneOfCluster::GetCurrentItem.n
.so mann/OneOfCluster::Init.n
.so mann/OneOfCluster::OneOfCluster.n
.so mann/OneOfCluster::SetItemOn.n
