.po -3
.nh
.TH "RestrTextItem" n "automatically Thu Mar 21 20:12:57 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
RestrTextItem.short \- an editable text line; the text must match a pattern
.SH DESCRIPTION
\fBRestrTextItem\fP is an editable text item whereby the entered text must match a certain pattern. This check is done on each typed character as well as on a paste operation. If the resulting text would not match the pattern, then the character or the text to be pasted is discarded.
.br
The pattern is a so called \fBregular expression\fP. Regular expressions are provided by the \fIclass RegularExp\fP and can be specified in the style of the GNU emacs editor.
.br
The following example shows how to create a \fBRestrTextItem\fP for entry of hexadecimal numbers:
.na
.nf

RegularExp *regex = new RegularExp("[0-9a-fA-F]*");
RestrTextItem *item = new RestrTextItem(cIdNone, regex, "", 100);
.ad b
.fi


.br
classes are never derived from \fBRestrTextItem\fP.
.br
class \fBRestrTextItem\fP
is sometimes reused directly.
.br
class \fBRestrTextItem\fP contains 1 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
EditTextItem
.ad b
.PD 0
.TP 20
\fBflags:\fR
ClipperFlags


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
RestrTextItem

.SH CATEGORIES

.na
Simple Dialog Items
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBEditTextItem.h

.SH KNOWN PROBLEMS

The installed \fBRestrTextView\fP is never deleted.
.SH HISTORY
joe@csesbg.at	Thu Sep 05 13:11 1991 MET DST
.br
