.po -3
.nh
.TH "Splitter" n "automatically Fri Mar 15 14:12:37 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
Splitter \- splits a View in up to four panes
.SH DESCRIPTION
A \fBSplitter\fP is able to split a \fBView\fP in up to four panes that show disconnected portions of the \fBView\fP and can be scrolled independently. The \fBView\fP is simultaneously installed in four \fBScrollers\fP whose size can be changed by moving the splitbars.
.br
The installed \fBVObject\fP must be a \fBView\fP because only the \fIclass View\fP implements the functionality to be displayed in more than one \fBClipper\fP.
.br
\fBSplitters\fP can be used, for example, when the initial window layout is created:
.na
.nf

Window *MyDocument::DoMakeWindows()
{
    View *myView = new MyView(/* ... */);
    return new Window(this, Point(400), eWinDefault,
               new Splitter(myView));
}

.ad b
.fi
See also \fIclass Clipper\fP and \fIclass Scroller\fP.

.br
classes are rarely derived from \fBSplitter\fP.
.br
class \fBSplitter\fP
is often reused directly.
.br
class \fBSplitter\fP contains 12 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
CompositeVObject
.ad b
.PD 0
.TP 20
\fBflags:\fR
CompositeVObjectFlags

.SH INSTANCE VARIABLES
.TP
.BR ms " (private Point)"
the minimum size for each of the four \fBClippers\fP

.TP
.BR split " (private Point)"
contains the position of the horizontal and vertical split bars. If the \fBx\fP or \fBy\fP component is negative, then the \fBView\fP is currently not split in the respective direction.

.TP
.BR vop " (private VObject *)"
the shown \fBView\fP. It must be an instance of the \fIclass View\fP because only \fBView\fP implements the behavior to be displayed in more than one \fBClipper\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
Splitter

.PD 0
.TP 20
implementation
Control
.br
GetMinSize
.br
Init
.br
Open
.br
PrintOn
.br
ReadFrom
.br
SendDown
.br
SetExtent
.br
SetOrigin
.br
SetSplit
.br
TestOpen

.SH CATEGORIES

.na
VObject Composition
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBSplitter.h

.SH HISTORY
joe@csesbg.at	Tue Sep 03 17:58 1991
.br
.so mann/Splitter::Control.n
.so mann/Splitter::GetMinSize.n
.so mann/Splitter::Init.n
.so mann/Splitter::Open.n
.so mann/Splitter::PrintOn.n
.so mann/Splitter::ReadFrom.n
.so mann/Splitter::SendDown.n
.so mann/Splitter::SetExtent.n
.so mann/Splitter::SetOrigin.n
.so mann/Splitter::SetSplit.n
.so mann/Splitter::Splitter.n
.so mann/Splitter::TestOpen.n
