.po -3
.nh
.TH "TextItem" n "automatically Fri Mar 15 14:06:41 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
TextItem \- a non-editable, one-line text with a certain font
.SH DESCRIPTION
The \fBTextItem\fP is a non-editable, one-line text. The \fBTextItem\fP displays a string in a certain font and reserves a gap between its border and the text. All three attributes, text, font and border, can be set individually. The string to be displayed should not contain newline or other control characters because they are not interpreted. If that is required, use an \fBEditTextItem\fP or a \fBStaticTextView\fP instead.

.br
classes are never derived from \fBTextItem\fP.
.br
class \fBTextItem\fP
is often reused directly.
.br
class \fBTextItem\fP contains 16 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
VObject
.ad b
.PD 0
.TP 20
\fBsubclasses:\fR
.na
PathSeparatorItem
.ad b
.PD 0
.TP 20
\fBflags:\fR
VObjFlags

.SH INSTANCE VARIABLES
.TP
.BR border " (protected Point)"
the horizontal and vertical gaps between the edges of the content rectangle and the text. It can be accessed with the \fImethod SetBorder\fP.

.TP
.BR font " (protected FontPtr)"
the font used for displaying the text. It can be accessed with the \fImethod GetFont\fP and the \fImethod SetFont\fP.

.TP
.BR text " (protected char *)"
the text to be displayed. It can be accessed with the \fImethod AsString\fP, the \fImethod SetString\fP and the \fImethod SetFString\fP.


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
AsString
.br
GetFont
.br
SetBorder
.br
SetFString
.br
SetFont
.br
SetString
.br
TextItem

.PD 0
.TP 20
implementation
Base
.br
Draw
.br
GetMinSize
.br
InspectorId
.br
PrintOn
.br
ReadFrom
.br
SetExtent
.br
~TextItem

.SH CATEGORIES

.na
Simple Dialog Items
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBTextItem.h

.SH HISTORY
joe@csesbg.at	Tue Sep 10 12:08 1991 MET DST
.br
.so mann/TextItem::AsString.n
.so mann/TextItem::Base.n
.so mann/TextItem::Draw.n
.so mann/TextItem::GetFont.n
.so mann/TextItem::GetMinSize.n
.so mann/TextItem::InspectorId.n
.so mann/TextItem::PrintOn.n
.so mann/TextItem::ReadFrom.n
.so mann/TextItem::SetBorder.n
.so mann/TextItem::SetExtent.n
.so mann/TextItem::SetFString.n
.so mann/TextItem::SetFont.n
.so mann/TextItem::SetString.n
.so mann/TextItem::TextItem.n
.so mann/TextItem::~TextItem.n
