.po -3
.TH "VObject::Detect" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::Detect \- instance method
.SH TEMPLATE
foundItem = VObject *
Detect(BoolFun compareFunction, void * compareFunctionArg)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDetect\fP searches a certain \fBVObject\fP in the \fBVObject Tree\fP starting at \fBthis\fP.
.br
\fBDetect\fP walks down the VObject tree, applies \fBcompareFunction\fP to each \fBVObject\fP and returns the first one where the \fBcompareFunction\fP returns \fBTRUE\fP.
.br
\fBDetect\fP is never called directly. The interface to this method are the \fImethod FindItem\fP and the \fImethod FindItemPtr\fP which call \fBDetect\fP with different compare functions. For example, it is possible to look for a \fBVObject\fP with a certain id.
.br
\fBDetect\fP should be overridden if the subclass contains one or more "child" VObjects to forward \fBDetect\fP also to its childs. The default implementation applies the \fBcompareFunction\fP only to \fBthis\fP.
.br
For example, the \fImethod CompositeVObject::Detect\fP first applies the \fBcompareFunction\fP to every VObject in its list and at last to itself. This way of searching a tree is generally called \fBdepth-first search\fP because it first tries to walk down the tree as deep as possible.
.br
Another good example is the \fImethod Menu::Detect\fP.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBBoolFun compareFunction
.br
This function is called with the following arguments \fB(item, item, compareFunctionArg)\fP whereby \fBitem\fP contains the VObject currently visited in the VObject tree.
.br
This function has to compare the \fBitem\fP with the \fBcompareFunctionArg\fP and return whether they are equal.
.TP
\fBvoid * compareFunctionArg
.br
is passed to the \fBcompareFunction\fP as third argument. See \fBcompareFunction\fP.
.SH RETURN ARGUMENT
.TP
\fBVObject * foundItem
.br
contains the first \fBVObject\fP where \fBcompareFunction\fP returns \fBTRUE\fP. It is \fBNULL\fP if \fBcompareFunction\fP never returns \fBTRUE\fP.
.SH CATEGORIES

.na
detect, overrider interface
.ad b

.SH FIRST DEFINITION
class VObject
.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

