.po -3
.TH "VObject::DispatchEvents" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::DispatchEvents \- instance method
.SH TEMPLATE
commandToPerform = Command *
DispatchEvents(Point locatorPoint, Token inputToken, Clipper * focusClipper)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDispatchEvents\fP is called by the \fImethod Input\fP if the \fBVObject\fP is enabled and contains the \fBlocatorPoint\fP (see \fImethod ContainsPoint\fP).
.br
\fBDispatchEvents\fP examines the \fBinputToken\fP and dispatches the events to the corresponding event handling methods (the methods with a name like \fBDo...Command\fP).
.br
The command returned by the \fImethod DoLeftButtonDownCommand\fP and the \fImethod DoMiddleButtonDownCommand\fP is not immediately returned unless it is \fBgNoChanges\fP. It is assumed to be a \fBmouse tracking command\fP. With that command the \fImethod TrackInContent\fP of the \fBfocusClipper\fP is called which starts mouse tracking.
.br
If the mouse has just entered or exited the area occupied by the \fBVObject\fP or one of the mouse buttons has been clicked then the mouse cursor shape is changed to that returned by the \fImethod GetCursor\fP.
.br
VObjects with childs should override this method and call the \fImethod Input\fP for every child which in turn will invoke this method. This is done, for example, by the \fIclass CompositeVObject\fP.
.br
See \fItechnote 'Event Handling'\fP.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBPoint locatorPoint
.br
contains the position of the mouse cursor at the time of the event. The \fBlocatorPoint\fP is always automatically transformed into the VObject's coordinate system.
.TP
\fBToken inputToken
.br
contains the whole information about the event. In contrast to the \fBlocatorPoint\fP the \fBPos\fP member of the \fIclass Token\fP is never transformed into local coordinate systems. A copy of the \fBinputToken\fP can always be found in the \fIvar gToken\fP.
.TP
\fBClipper * focusClipper
.br
the \fBClipper\fP that currently has the input focus
.SH RETURN ARGUMENT
.TP
\fBCommand * commandToPerform
.br
contains a command to be executed by one of the next event handlers which is usually a \fBDocument\fP (see \fImethod Document::PerformCommand\fP). If the \fBinputToken\fP is not handled then \fBgNoChanges\fP is returned.
.SH CATEGORIES

.na
event handling, overrider interface
.ad b

.SH FIRST DEFINITION
class VObject
.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

