.po -3
.TH "VObject::DoOnItem" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::DoOnItem \- instance method
.SH TEMPLATE
void DoOnItem(int selectionState, VObject * selectedItem, Point where)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBDoOnItem\fP is generally called when VObjects are \fBselected\fP while the mouse button is kept depressed. VObjects can be selected if they are put in a \fBCollectionView\fP or if they are instances of the \fIclass Button\fP.
.br
The selection is done with mouse tracking commands. During tracking the current selected item can change its selected state if the mouse is moved in or out of the item's content rectangle. The possible values of the \fBselectionState\fP reflect these \fBselection change events\fP.
Method is sometimes overridden.
.SH ARGUMENTS
.TP
\fBint selectionState
.br
the current state of the selection. See the \fImethod CollectionView::SetSelection\fP and the \fImethod ButtonCommand::TrackMouse\fP for the possible values of the \fBselectionState\fP.
.TP
\fBVObject * selectedItem
.br
the currently selected or deselected item. If it is \fBNULL\fP then \fBselectionState\fP applies to \fBthis\fP.
.TP
\fBPoint where
.br
contains the current position of the mouse within the \fBselectedItem\fP.
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
event handling, overrider interface
.ad b

.SH FIRST DEFINITION
class VObject
.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

