.po -3
.TH "VObject::FindItem" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::FindItem \- instance method
.SH TEMPLATE
item = VObject *
FindItem(Point at)
.SH SPECIFIERS
public
.SH DESCRIPTION
Starting at \fBthis\fP the method \fBFindItem\fP searches the VObject tree for an item which contains the point \fBat\fP. The test is based on the \fImethod ContainsPoint\fP. \fBFindItem\fP uses the \fImethod Detect\fP to walk down the tree. This method is called, for example, by the \fImethod InspectCommand::TrackMouse\fP.
.SH ARGUMENTS
.TP
\fBPoint at
.br
an item which contains \fBat\fP is searched
.SH RETURN ARGUMENT
.TP
\fBVObject * item
.br
the found item or \fBNULL\fP
.SH CATEGORIES

.na
detect, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

.po -3
.TH "VObject::FindItem" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::FindItem \- instance method
.SH TEMPLATE
item = VObject *
FindItem(int id)
.SH SPECIFIERS
public
.SH DESCRIPTION
Starting at \fBthis\fP the method \fBFindItem\fP searches the VObject tree for an item with \fBid\fP. If \fBid\fP is \fIconst cIdNone\fP then \fBNULL\fP is returned without searching. \fBFindItem\fP uses the \fImethod Detect\fP to walk down the tree.
.br
This method is used, for example, by the \fIclass Menu\fP to find menu items with certain ids in order to enable/disable these items or to change their text. To do this the \fBMenu\fP also overrides the method \fBDetect\fP. See \fImethod Menu::Detect\fP.
.SH ARGUMENTS
.TP
\fBint id
.br
an item with \fBid\fP is searched
.SH RETURN ARGUMENT
.TP
\fBVObject * item
.br
the found item or \fBNULL\fP
.SH CATEGORIES

.na
detect, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

.po -3
.TH "VObject::FindItem" n "automatically Mon Apr  8 20:17:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
VObject::FindItem \- instance method
.SH TEMPLATE
itemFound = VObject *
FindItem(VObject * item)
.SH SPECIFIERS
public
.SH DESCRIPTION
Starting at \fBthis\fP the method \fBFindItem\fP searches the VObject tree for an item which is equal to \fBitem\fP. In contrast to the \fImethod FindItemPtr\fP the comparison is based on the \fImethod IsEqual\fP (=equality test). \fBFindItem\fP uses the \fImethod Detect\fP to walk down the tree. This method is called, for example, by the \fImethod TreeNode::FindExpandedItem\fP.
.SH ARGUMENTS
.TP
\fBVObject * item
.br
an item which is equal to \fBitem\fP is searched
.SH RETURN ARGUMENT
.TP
\fBVObject * itemFound
.br
the found item or \fBNULL\fP
.SH CATEGORIES

.na
detect, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBVObject.C

