.po -3
.nh
.TH "VObjectPair" n "automatically Fri Mar 15 14:14:25 1991" "ET++ version v2.2" "ET++ class description"
.SH NAME
VObjectPair \- aligns two VObjects horizontally
.SH DESCRIPTION
The \fBVObjectPair\fP manages two other \fBVObjects\fP. It is often used to display an item with a label, e.g. the items in a file dialog (see \fIclass FileItem\fP) or a button and its label (see \fIclass LabeledButton\fP). Therefore it aligns them horizontally along their baselines with a certain gap between them.

.br
classes are sometimes derived from \fBVObjectPair\fP.
.br
class \fBVObjectPair\fP
is sometimes reused directly.
.br
class \fBVObjectPair\fP contains 14 methods.
.PD 0
.TP 20
\fBowner of class:\fR
nobody.
.PD 0
.TP 20
\fBbaseclasses:\fR
.na
VObject
.ad b
.PD 0
.TP 20
\fBsubclasses:\fR
.na
FileItem, LabeledButton, MenuItem, PopupItem
.ad b
.PD 0
.TP 20
\fBflags:\fR
VObjFlags

.SH INSTANCE VARIABLES
.TP
.BR gap " (protected Point)"
the gap between the left and right \fBVObject\fP

.TP
.BR left " (protected VObject *)"
the \fBVObject\fP at the left

.TP
.BR right " (protected VObject *)"
the \fBVObject\fP at the right


.SH INSTANCE METHOD LIST

.PD 0
.TP 20
client interface
VObjectPair

.PD 0
.TP 20
implementation
Base
.br
DispatchEvents
.br
Draw
.br
Enable
.br
FreeAll
.br
GetMinSize
.br
Parts
.br
PrintOn
.br
ReadFrom
.br
SendDown
.br
SetContainer
.br
SetExtent
.br
SetOrigin

.SH CATEGORIES

.na
VObject Composition
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBVObjectPair.h

.SH KNOWN PROBLEMS

\fBVObjectPair\fP does not implement the \fImethod Detect\fP making it impossible to look for items in the \fBVObject\fP trees below through the \fImethod FindItem\fP.
.SH HISTORY
joe@csesbg.at	Mon Sep 09 12:21 1991 MET DST
.br
.so mann/VObjectPair::Base.n
.so mann/VObjectPair::DispatchEvents.n
.so mann/VObjectPair::Draw.n
.so mann/VObjectPair::Enable.n
.so mann/VObjectPair::FreeAll.n
.so mann/VObjectPair::GetMinSize.n
.so mann/VObjectPair::Parts.n
.so mann/VObjectPair::PrintOn.n
.so mann/VObjectPair::ReadFrom.n
.so mann/VObjectPair::SendDown.n
.so mann/VObjectPair::SetContainer.n
.so mann/VObjectPair::SetExtent.n
.so mann/VObjectPair::SetOrigin.n
.so mann/VObjectPair::VObjectPair.n
