.po -3
.TH "View::ConstrainScroll" n "automatically Mon Apr  8 20:17:22 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
View::ConstrainScroll \- instance method
.SH TEMPLATE
void ConstrainScroll(Point * viewPosition)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBConstrainScroll\fP is called whenever a \fBClipper\fP, that shows \fBthis\fP, scrolls. Overriding this method gives the possibility to constrain the scrolling by modifying the \fBviewPosition\fP.
.br
By default, the \fBviewPosition\fP is not modified which results in a pixel-wise scrolling. For example, the \fImethod FixedLineTextView::ConstrainScroll\fP allows vertical scrolling to be done only in units of its line height. Similarly, the \fImethod CollectionView::ConstrainScroll\fP constrains vertical scrolling to be done "item-wise".
.br
See also \fImethod Scroll\fP and \fImethod Clipper::Scroll\fP.
Method is rarely overridden.
.SH ARGUMENTS
.TP
\fBPoint * viewPosition
.br
is the upper left corner of the portion of \fBthis\fP that is revealed through scrolling. Constraining can be done by modifying the \fBviewPosition\fP.
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
scrolling, overrider interface
.ad b

.SH FIRST DEFINITION
class View
.SH FILES
.PD 0
.TP 20
implementation:
\fBView.C

