.po -3
.TH "View::Scroll" n "automatically Mon Apr  8 20:17:22 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
View::Scroll \- instance method
.SH TEMPLATE
void Scroll(int mode, Point amount, bool redraw = TRUE)
.SH SPECIFIERS
public
.SH DESCRIPTION
\fBScroll\fP scrolls \fBthis\fP the specified \fBamount\fP and in the direction determined by \fBmode\fP.
.br
\fBScroll\fP actually forwards this message either to the \fIinstvar focus\fP or to all Clippers in the \fIinstvar clippers\fP or to the next \fBView\fP in the container chain.
.br
See also \fImethod Clipper::Scroll\fP, \fImethod RevealRect\fP, \fImethod RevealAlign\fP and \fImethod ConstrainScroll\fP.
.SH ARGUMENTS
.TP
\fBint mode
.br
determines the type of scrolling and specifies how to interpret the \fBamount\fP. It is one of the following constants: \fIconst cPartScrollStep cPartScrollPage cPartScrollAbs cPartScrollHAbs cPartScrollVAbs cPartScrollRel cPartScrollPos\fP.
.TP
\fBPoint amount
.br
contains how much to scroll and in which direction. The direction is indicated by the sign of the \fBx\fP and \fBy\fP components. Positive values mean scrolling to the right or bottom. Depending on the \fBmode\fP the \fBamount\fP is either relative to the current scrolling position or it contains an absolute position.
.TP
\fBbool redraw = TRUE
.br
If \fBredraw\fP is \fBTRUE\fP, then the scrolling \fBClipper\fP will redraw (with the \fImethod UpdateEvent\fP) its whole content rectangle before and after scrolling. Otherwise it will only update its internal scrolling position.
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
scrolling, forwarding, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBView.C

