.po -3
.TH "View::ShowInAllClippers" n "automatically Mon Apr  8 20:17:22 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
View::ShowInAllClippers \- instance method
.SH TEMPLATE
void ShowInAllClippers(VoidObjMemberFunc aMethod, Object * anObject, void * arg1 = 0, void * arg2 = 0, void * arg3 = 0, void * arg4 = 0)
.SH SPECIFIERS
public
virtual
.SH DESCRIPTION
\fBShowInAllClippers\fP forwards this message either to the \fImethod Clipper::DrawInFocus\fP of all Clippers in the \fIinstvar clippers\fP or to the next \fBView\fP in the container chain.
.br
\fBShowInAllClippers\fP is only called when a mouse tracking command is executed by the \fImethod Clipper::TrackInContent\fP in order to draw the feedback of the command in all Clippers of \fBthis\fP. See also \fImethod Clipper::FeedbackOnce\fP and \fImethod Clipper::Feedback\fP.
Method is never overridden.
.SH ARGUMENTS
.TP
\fBVoidObjMemberFunc aMethod
.br
a reference to a method of \fBanObject\fP. It is always the \fImethod Clipper::Feedback\fP.
.TP
\fBObject * anObject
.br
this object gets the message \fBaMethod\fP. It is always the \fBClipper\fP that currently tracks the mouse.
.TP
\fBvoid * arg1 = 0
.br
1st argument for \fBaMethod\fP
.TP
\fBvoid * arg2 = 0
.br
2nd argument for \fBaMethod\fP
.TP
\fBvoid * arg3 = 0
.br
3rd argument for \fBaMethod\fP
.TP
\fBvoid * arg4 = 0
.br
4th argument for \fBaMethod\fP
.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
drawing, mouse tracking, implementation
.ad b

.SH FIRST DEFINITION
class View
.SH FILES
.PD 0
.TP 20
implementation:
\fBView.C

.SH KNOWN PROBLEMS

Drawing the mouse tracking feedback in all Clippers of a \fBView\fP can be implemented much simpler so that the method \fBShowInAllClippers\fP could be removed. The mouse tracking \fBClipper\fP has to get the \fBClipper\fP list of the \fBView\fP and directly invoke the method \fBFeedback\fP of each opened \fBClipper\fP in the list.
