.po -3

.TH "enums" n "automatically Mon Apr  8 20:19:25 1991" "ET++ version " "ET++ enumeration description"
.SH ENUMERATION NAME
\fBBWinFlags
.SH DESCRIPTION
\fBBWinFlags\fP is the set of flags for the \fIclass BlankWin\fP.
This enumeration is a bitset..SH ENUMITEMS
.TP
\fBeBWinOverlay
description
This is a hint for the window system to save the area under the window before it is opened and restore that area after closing. The advantage is that the underlying windows need not redraw themselves if they are exposed again.
.br
\fBeBWinOverlay\fP is set for rather small windows that are visible only a short time, e.g. menus and alerts.
.TP
\fBeBWinBlock
description
If \fBeBWinBlock\fP is set and the window is opened, then all other windows of the application are blocked until the window is closed again. Blocked means that only the just opened window gets mouse and keyboard events. This kind of windows are called modefull (or also modal) and are used for menus, alerts, file dialogs, etc. Normal windows, however, are referred to as modeless. Modefull windows may be nested. For example, a modefull dialog opens another modefull dialog which pops up a menu with a submenu, and so on.
.TP
\fBeBWinActive
description
The \fIclass Window\fP sets this flag when the mouse cursor enters the window. It is used to highlight the window title area showing that the window has the keyboard focus.
.TP
\fBeBWinFixed
description
If \fBeBWinFixed\fP is set, then the associated window is not resizable. The \fIclass Dialog\fP automatically sets this flag if \fBeBWinBlock\fP is set.
.TP
\fBeBWinWasOpen
description
The \fIclass Document\fP sets this flag when the windows of a document are iconified according to their open state. When the document is deiconified again it knows which windows to reopen.
.TP
\fBeBWinDefault
description
The default set of flags is \fB0\fP.
.TP
\fBeBWinLast
description
The first flag of subclasses is \fBBIT(eBWinLast+1)\fP.
.SH CATEGORIES

.na
Graphic Foundation
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBBlankWin.h
.SH HISTORY
joe@csesbg.at	Fri Sep 06 09:56 1991 MET DST
.br
