

.SH MACRO NAME
\fBBool(
bool boolVariable)
.SH DESCRIPTION
\fBBool\fP converts integer variables to variables of type \fBbool\fP. This is used in the \fImethod Object::ReadFrom\fP to read the values of boolean variables from C++ streams. For example:
.na
.nf

istream& MyClass::ReadFrom(istream& is)
{
    bool b;
    return is \>\> Bool(b);
}


.ad b
.fi
See also \fImacro Enum\fP.
macro \fBBool\fP is sometimesused.
.SH ARGUMENTS
.TP
\fBbool boolVariable
.br
a variable of type \fBbool\fP
.SH CATEGORIES

.na
inputoutput
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBTypes.h
.SH HISTORY
joe@csesbg.at	Mon Jun 17 19:47 1991	reworked
.br
joe@csesbg.at	Wed Jun 19 18:24 1991	added IsKindOf, Guard
.br
