

.SH MACRO NAME
\fBEnum(
enum anyEnumType enumVariable)
.SH DESCRIPTION
\fBEnum\fP converts integer variables to variables of enum types. This is used in the \fImethod Object::ReadFrom\fP to read the values of enums from C++ streams. For example:
.na
.nf

istream& MyClass::ReadFrom(istream& is)
{
    enum VObjAlign alignFlags;
    return is \>\> Enum(alignFlags);
}


.ad b
.fi
See also \fImacro Bool\fP.
macro \fBEnum\fP is sometimesused.
.SH ARGUMENTS
.TP
\fBenum anyEnumType enumVariable
.br
a variable of any enum type
.SH CATEGORIES

.na
inputoutput
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBTypes.h
.SH HISTORY
joe@csesbg.at	Mon Jun 17 19:47 1991	reworked
.br
joe@csesbg.at	Wed Jun 19 18:24 1991	added IsKindOf, Guard
.br
