

.SH MACRO NAME
\fBIsKindOf(
name className)
.SH DESCRIPTION
\fBIsKindOf\fP checks whether an object is an instance of the class \fBclassName\fP or of a subclass of \fBclassName\fP. Example:
.na
.nf

Object *op = new TextItem (/* ... */);
if (op-\>IsKindOf(VObject))	// TRUE
    ...
if (op-\>IsKindOf(View))	// FALSE
    ...


.ad b
.fi
\fBIsKindOf\fP can only be applied to objects whose class definition have been defined and implemented with the \fImacro MetaDef\fP and the \fImacro MetaImpl\fP.
.br
\fBIsKindOf\fP is actually only the interface for the \fImethod Class::isKindOf\fP.
.br
See also the \fImacro Guard\fP.
macro \fBIsKindOf\fP is sometimesused.
.SH ARGUMENTS
.TP
\fBname className
.br
the name of the class which the checked object should be an instance of
.SH CATEGORIES

.na
metaclass
.ad b

.SH FILES
.PD 0
.TP 20
declaration:
\fBObject.h
.SH HISTORY
joe@csesbg.at	Mon Jun 17 19:47 1991	reworked
.br
joe@csesbg.at	Wed Jun 19 18:24 1991	added IsKindOf, Guard
.br
