.po -3
.TH "Object::DelayChanges" n "automatically Fri Mar 1 10:54:57 1991" "ET++ version v2.2" "ET++ method description"
.SH NAME
Object::DelayChanges \- instance method
.SH TEMPLATE
void DelayChanges()
.SH SPECIFIERS
public
.SH DESCRIPTION
Increments the delayed change message counter by one. DelayChanges
is the counterpart of FlushChanges.
.br
Hint: DelayChanges and FlushChanges are usually not called directly. The
utility \fIclass DoDelayChanges\fP is used instead that exploits
automatic destruction.
.br
An example how to use DoDelayChanges can be found in the \fImethod
VObjectText::Cut\fP and the \fImethod StyledText::Cut\fP.
.br
See also \fItechnote 'Change Propagation'\fP.
.SH ARGUMENTS
none

.SH RETURN ARGUMENT
void

.SH CATEGORIES

.na
change propagation, client interface
.ad b

.SH FILES
.PD 0
.TP 20
implementation:
\fBObject.C

.SH KNOWN PROBLEMS

(1) Although the delayed change messages should be discarded if their
sender (the observed object in question) is deleted, the current
implementation does not do it. This will be fixed in future versions.
.br

(2) Clients (and suppliers as well) have to take care that the objects
referenced by a delayed change message are still living until the change
message is eventually forwarded.
